---
schema_version: "1"
id: 91dbf10d4e0149facfff039484f64779a7c9213a807ccaa272e99b2928f6fff6
title: Products
collection: developer
version: current
locale: en-us
portal_url: https://docs.salesforce.com/developer/current/en-us/commerce-cloud/commerce-api/references/generated-api-specs/products.md
canonical_url: https://developer.salesforce.com/docs/commerce/commerce-api/references/products
source_site: developer.salesforce.com
content_type: documentation
content_hash: f7fa36521ad54bbc361466a64f03112d84019afdb6f58d9621f48fc2ea9257f7
products:
  - B2C Commerce API
  - Salesforce APIs
---
Products

# Products

[Download API specification](https://developer.salesforce.com/static/commercecloud/commerce-api/products/products-oas-v1-public.yaml)

## API Overview

The Products API enables you to build merchandising apps that merchandisers use to add products to catalogs, configure products for your storefront, and manage products in their ecommerce channels.

For more information, see [Products](https://documentation.b2c.commercecloud.salesforce.com/DOC1/topic/com.demandware.dochelp/content/b2c_commerce/topics/products/b2c_products.html) in the Salesforce B2C Commerce Infocenter.

### Authentication & Authorization

The client managing product information must have access to the Products resource. This API requires a bearer token in the header of the request. The client accessing the API must first authenticate against Account Manager to get the bearer token.

You must include the relevant scope(s) in the client ID used to generate the SLAS token. For a full list of required permissions, see the [Authorization Scopes Catalog.](https://developer.salesforce.com/docs/commerce/commerce-api/guide/auth-z-scope-catalog.html)

### Use Cases

#### Add Products

Use the Products API to add new products to a catalog. You can add or update product details like attributes, variations, variation attributes, and images. You can also use the API to change a product’s catalog assignment.

If you are adding products from an external product information management (PIM) system, use the Mulesoft Accelerator component created for Commerce Cloud.

For more detail, see [Variation Groups](https://documentation.b2c.commercecloud.salesforce.com/DOC1/topic/com.demandware.dochelp/content/b2c_commerce/topics/products/b2c_variation_groups.html) in the Salesforce B2C Commerce Infocenter.

![b2c-commerce-products-screenshot-1.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-products-screenshot-1.png)

#### Create & Validate Variation Groups

Use the API to enable a shopper to switch between different variants on a product page. You can group variation products into variation groups or group master products by one or more attributes. The variants within a variation group are linked. Linked variants allow a shopper to switch between different variants.

For more detail, see [Variation Groups](https://documentation.b2c.commercecloud.salesforce.com/DOC1/topic/com.demandware.dochelp/content/b2c_commerce/topics/products/b2c_variation_groups.html) in the Salesforce B2C Commerce Infocenter.

![b2c-commerce-products-screenshot-2.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-products-screenshot-2.png)

#### Search for Variants

Use the Product API to enable merchants to use a set of filtering and sorting criteria to search for variants assigned to a master product, or variation group.

For more detail, see [Product Variations](https://documentation.b2c.commercecloud.salesforce.com/DOC1/topic/com.demandware.dochelp/content/b2c_commerce/topics/products/b2c_product_variations.html) in the Salesforce B2C Commerce Infocenter.

![b2c-commerce-products-screenshot-3.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-products-screenshot-3.png)

#### Manage Product Options

Use the API to view and manage product options for a given product so that optional accessories, upgrades, or services can be sold with the product. For example, a product warranty or monogramming.

For more detail, see [Product Options](https://documentation.b2c.commercecloud.salesforce.com/DOC1/topic/com.demandware.dochelp/content/b2c_commerce/topics/products/b2c_product_options.html) in the Salesforce B2C Commerce Infocenter.

![b2c-commerce-products-screenshot-4.png](https://resources.docs.salesforce.com/rel1/doc/en-us/static/misc/b2c-commerce-products-screenshot-4.png)

**Version:** 1.2.0

## Servers

*   `https://{shortCode}.api.commercecloud.salesforce.com/product/products/v1`
    *   `shortCode (default shortCode)`

## Security

*   `AmOAuth2` (oauth2) AccountManager OAuth 2.0 bearer token Authentication.
    *   OAuth flow clientCredentials (tokenUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
    *   Scope sfcc.products: Product scope READONLY
    *   Scope sfcc.products.rw: Product scope
    *   OAuth flow authorizationCode (authorizationUrl: https://account.demandware.com/dwsso/oauth2/authorize, tokenUrl: https://account.demandware.com/dwsso/oauth2/access\_token)
    *   Scope sfcc.products: Product scope READONLY
    *   Scope sfcc.products.rw: Product scope

## Operations

### GET Get product information.

`GET /organizations/{organizationId}/products/{productId}`

Operation ID: `getProduct`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Retrieve detailed information about a specific product.

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId) The site context.

#### Responses

*   **200** Retrieved product information successfully.
    
    Media type: `application/json`. Schema: `Product`.
    
    _Example: DataProductExpand_
    
    ```
    {
      "assignedCategories": [
        {
          "catalogId": "apparel-catalog",
          "categoryId": "mens-accessories"
        },
        {
          "catalogId": "storefront-catalog-en",
          "categoryId": "top-seller"
        },
        {
          "catalogId": "storefront-catalog-en",
          "categoryId": "electronics-gaming"
        }
      ],
      "brand": "Apple",
      "classificationCategory": {
        "catalogId": "storefront-catalog-en",
        "categoryId": "top-seller"
      },
      "creationDate": "2019-02-21T22:10:02.000Z",
      "id": "apple-ipod-classic",
      "image": {
        "absUrl": "https://example.com/images/large/ipod-classic-silver.jpg",
        "alt": {
          "default": "Apple iPod Classic, , large"
        },
        "path": "large/ipod-classic-silver.jpg",
        "title": {
          "default": "Apple iPod Classic, "
        }
      },
      "imageGroups": [
        {
          "images": [
            {
              "absUrl": "https://example.com/images/large/ipod-classic-silver.jpg",
              "alt": {
                "default": "Apple iPod Classic, , large"
              },
              "path": "large/ipod-classic-silver.jpg",
              "title": {
                "default": "Apple iPod Classic, "
              }
            }
          ],
          "viewType": "large"
        },
        {
          "images": [
            {
              "absUrl": "https://example.com/images/medium/ipod-classic-silver.jpg",
              "alt": {
                "default": "Apple iPod Classic, , medium"
              },
              "path": "medium/ipod-classic-silver.jpg",
              "title": {
                "default": "Apple iPod Classic, "
              }
            }
          ],
          "viewType": "medium"
        },
        {
          "images": [
            {
              "absUrl": "https://example.com/images/small/ipod-classic-silver.jpg",
              "alt": {
                "default": "Apple iPod Classic, , small"
              },
              "path": "small/ipod-classic-silver.jpg",
              "title": {
                "default": "Apple iPod Classic, "
              }
            }
          ],
          "viewType": "small"
        }
      ],
      "lastModified": "2019-08-28T18:49:09.000Z",
      "localizedTaxClassId": {
        "de": "exempt",
        "default": "standard",
        "en-US": "exempt"
      },
      "longDescription": {
        "default": {
          "markup": "Supports MP3, MP3 VBR, AAC, Protected AAC, Audible 2, 3 and 4, Apple Lossless and AIFF audio formats; also supports JPEG, BMP, GIF, TIFF, PSD (Mac only) and PNG image formats and H.264 (high-definition), MPEG-4 and MPEG-4 video formats",
          "source": "Supports MP3, MP3 VBR, AAC, Protected AAC, Audible 2, 3 and 4, Apple Lossless and AIFF audio formats; also supports JPEG, BMP, GIF, TIFF, PSD (Mac only) and PNG image formats and H.264 (high-definition), MPEG-4 and MPEG-4 video formats"
        }
      },
      "name": {
        "default": "Apple iPod Classic"
      },
      "onlineFlag": {
        "default": true
      },
      "owningCatalogId": "electronics-catalog",
      "owningCatalogName": {
        "default": "Electronics Master Catalog"
      },
      "pageDescription": {
        "default": "This iPod delivers everything you love about iPod with added features all wrapped in a tiny 4.9 oz. package. With 120GB of storage and up to 36 hours music playback, iPod classic lets you enjoy up to 30,000 songs or 150 hours of video — or a combination — wherever you go."
      },
      "pageKeywords": {
        "default": "Apple, iPod, iPod Classic, MP3, Music Player"
      },
      "pageTitle": {
        "default": "Apple iPod Nano"
      },
      "primaryCategories": [
        {
          "catalogId": "apparel-catalog",
          "categoryId": "mens-accessories"
        },
        {
          "catalogId": "storefront-catalog-en",
          "categoryId": "top-seller"
        }
      ],
      "primaryCategoryId": "top-seller",
      "searchable": {
        "default": true
      },
      "shortDescription": {
        "default": {
          "markup": "This iPod delivers everything you love about iPod with added features all wrapped in a tiny 4.9 oz. package. With 120GB of storage and up to 36 hours music playback, iPod classic lets you enjoy up to 30,000 songs or 150 hours of video — or a combination — wherever you go.",
          "source": "This iPod delivers everything you love about iPod with added features all wrapped in a tiny 4.9 oz. package. With 120GB of storage and up to 36 hours music playback, iPod classic lets you enjoy up to 30,000 songs or 150 hours of video — or a combination — wherever you go."
        }
      },
      "taxClassId": "standard",
      "type": {
        "master": true
      },
      "validFrom": {
        "default": "1998-05-03T00:00:00.000Z",
        "default@SiteGenesis": "1998-05-11T00:00:00.000Z"
      },
      "validTo": {
        "default": "2028-07-03T00:00:00.000Z",
        "default@SiteGenesis": "2028-05-30T00:03:00.000Z"
      },
      "variants": [
        {
          "productId": "apple-ipod-classic-silver-120g",
          "variationValues": {
            "color": "Silver",
            "memorySize": "120 GB"
          }
        },
        {
          "productId": "apple-ipod-classic-black-120g",
          "variationValues": {
            "color": "Black",
            "memorySize": "120 GB"
          }
        }
      ],
      "variationAttributes": [
        {
          "attributeDefinitionId": "color",
          "attributeDefinitionName": {
            "default": "Color"
          },
          "id": "color",
          "name": {
            "default": "Color"
          },
          "shared": true,
          "slicing": false,
          "values": [
            {
              "name": {
                "default": "Silver"
              },
              "position": 1,
              "value": "Silver"
            },
            {
              "name": {
                "default": "Black"
              },
              "position": 2,
              "value": "Black"
            },
            {
              "name": {
                "default": "Purple"
              },
              "position": 3,
              "value": "Purple"
            },
            {
              "name": {
                "default": "Blue"
              },
              "position": 4,
              "value": "Blue"
            },
            {
              "name": {
                "default": "Green"
              },
              "position": 5,
              "value": "Green"
            },
            {
              "name": {
                "default": "Yellow"
              },
              "position": 6,
              "value": "Yellow"
            },
            {
              "name": {
                "default": "Orange"
              },
              "position": 7,
              "value": "Orange"
            },
            {
              "name": {
                "default": "Red"
              },
              "position": 8,
              "value": "Red"
            },
            {
              "name": {
                "default": "Fuscia"
              },
              "position": 9,
              "value": "Fuscia"
            }
          ],
          "variationAttributeType": "string"
        },
        {
          "attributeDefinitionId": "memorySize",
          "attributeDefinitionName": {
            "default": "Memory Size"
          },
          "id": "memorySize",
          "name": {
            "default": "Memory Size"
          },
          "shared": true,
          "slicing": false,
          "values": [
            {
              "name": {
                "default": "1 GB"
              },
              "position": 1,
              "value": "1 GB"
            },
            {
              "name": {
                "default": "2 GB"
              },
              "position": 2,
              "value": "2 GB"
            },
            {
              "name": {
                "default": "8 GB"
              },
              "position": 3,
              "value": "8 GB"
            },
            {
              "name": {
                "default": "16 GB"
              },
              "position": 4,
              "value": "16 GB"
            },
            {
              "name": {
                "default": "32 GB"
              },
              "position": 5,
              "value": "32 GB"
            },
            {
              "name": {
                "default": "120 GB"
              },
              "position": 6,
              "value": "120 GB"
            }
          ],
          "variationAttributeType": "string"
        }
      ]
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: getProduct400_
    
    ```
    {
      "title": "Unqueryable Field",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/unqueryable-field",
      "detail": "The field 'link' can't be queried.",
      "field": "link"
    }
    ```
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: getProduct401_
    
    ```
    {
      "title": "Invalid Access Token",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/invalid-access-token",
      "detail": "The request is unauthorized, the access token is invalid.",
      "accessToken": "hbGciOiJIUzI1NiIsInR5cCI6Ikp"
    }
    ```
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example: getProduct404_
    
    ```
    {
      "title": "Product Not Found",
      "type": "https://api.commercecloud.salesforce.com/documentation/error/v1/errors/product-not-found",
      "detail": "No product with ID '1585183329877' could be found.",
      "productId": "1585183329877"
    }
    ```
    

### PUT Create or overwrite a product with provided data.

`PUT /organizations/{organizationId}/products/{productId}`

Operation ID: `createProduct`. Security: AmOAuth2 (sfcc.products.rw).

Create a product using the information provided. If a product with the same unique identifier exists, it is overwritten.

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `Product`.

_Example DataProductExpand: same as GET /organizations/{organizationId}/products/{productId} 200 response._

#### Responses

*   **200** Product was updated successfully.
    
    Media type: `application/json`. Schema: `Product`.
    
    _Example DataProductExpand: same as GET /organizations/{organizationId}/products/{productId} 200 response._
    
*   **201** Product was created successfully.
    
    Media type: `application/json`. Schema: `Product`.
    
    _Example DataProductExpand: same as GET /organizations/{organizationId}/products/{productId} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Deletes the product by ID.

`DELETE /organizations/{organizationId}/products/{productId}`

Operation ID: `deleteProduct`. Security: AmOAuth2 (sfcc.products.rw).

Permanently remove a product by ID.

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted the product successfully.
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PATCH Partially update fields of an existing product.

`PATCH /organizations/{organizationId}/products/{productId}`

Operation ID: `updateProduct`. Security: AmOAuth2 (sfcc.products.rw).

Update a product using the information provided. Fields that can be updated: name, pageDescription, longDescription, pageTitle, pageKeywords, brand, ean, upc, manufactureSku, manufactureName, searchable, unit, searchable, onlineFlag, defaultVariantId. Custom attributes are used to extend a standard Product system object. This endpoint can be used to update custom attribute values for a particular product SKU. If you try to update a non-existent custom attribute, the request won't fail, but no changes are made and the attribute is not created.

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `Product`.

_Example DataProductExpand: same as GET /organizations/{organizationId}/products/{productId} 200 response._

#### Responses

*   **200** Updated the product successfully.
    
    Media type: `application/json`. Schema: `Product`.
    
    _Example DataProductExpand: same as GET /organizations/{organizationId}/products/{productId} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### POST Search product variations using complex queries and filters.

`POST /organizations/{organizationId}/products/{productId}/variant-search`

Operation ID: `searchProductVariations`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Search product variations for master product or variation group product. The query attribute specifies a complex query that can be used to narrow down the search.

This is the list of searchable attributes:

| Attribute | Type |
| --- | --- |
| id | String |
| productId | String |
| name | String |
| online | SiteSpecific Boolean |
| inStock | Boolean |
| searchable | SiteSpecific Boolean |
| ats - Available quantity to sell | Double |
| variationAttribute.ATTRIBUTE\_ID (Ex:variation\_attribute.color) | String |

Sortable Fields:

| Attribute | Type |
| --- | --- |
| id | String |
| productId | String |
| name | String |
| online | SiteSpecific Boolean |
| inStock | Boolean |
| searchable | SiteSpecific Boolean |
| ats - Available quantity to sell | Double |

Note: The calculated value of "online" and "searchable" is used in the search/sort. A search/sort by the site-specific attributes require the Site ID query parameter to be set. They are "online", "inStock", "searchable" and "ats". We assume that every field that starts with variationAttribute. is searchable and dot is followed by "ATTRIBUTE\_ID".

The list of expansions to retrieve product information. The expand values available are:

*   \_base - Basic product information is retrieved. This expand is included by default.
    
*   all - All product information, including the following properties are retrieved:
    
    *   image
    *   price - siteId must be provided to see this property
    *   priceCurrency - siteId must be provided to see this property
*   availability - Information related to the availability of the product variation. This expand is not included by default.
    
    *   ats - siteId must be provided to see this property
    *   inStock - siteId must be provided to see this property
    *   online - siteId must be provided to see this property
    *   searchable
*   variations - Information related to product variations is retrieved. This expand is included by default.
    
*   attributes - Information related to product variation attributes is retrieved. This expand is not included by default.
    

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId) The site context.

#### Request body (required)

Media type: `application/json`. Schema: `VariantSearchRequest`.

_Example: VariantSearchRequestBody_

```
{
  "query": {
    "textQuery": {
      "fields": [
        "id"
      ],
      "searchPhrase": "ipod"
    }
  },
  "expand": [
    "variations"
  ]
}
```

#### Responses

*   **200** Search results returned.
    
    Media type: `application/json`. Schema: `VariantSearchResult`.
    
    _Example: VariantSearchResult_
    
    ```
    {
      "limit": 2,
      "hits": [
        {
          "defaultProductVariation": false,
          "productId": "apple-ipod-classic-silver-120g",
          "variationValues": {
            "color": "Silver",
            "memorySize": "120 GB"
          }
        },
        {
          "defaultProductVariation": false,
          "productId": "apple-ipod-classic-black-120g",
          "variationValues": {
            "color": "Black",
            "memorySize": "120 GB"
          }
        }
      ],
      "query": {
        "textQuery": {
          "fields": [
            "id"
          ],
          "searchPhrase": "ipod"
        }
      },
      "offset": 0,
      "total": 2
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET List all variation groups of a product.

`GET /organizations/{organizationId}/products/{masterProductId}/variation-groups`

Operation ID: `getVariationGroupsForMasterProduct`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

List all variation groups of a product.

#### Parameters

*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId) The site context.
*   `limit` (query, integer (int32)) Number of records to retrieve per request. Must be between 1 (minimum) and 50 (maximum). Defaults to 25.  
    Default: `25`. Minimum: 1. Maximum: 50.
*   `offset` (query, integer (int32)) Used to retrieve the results based on a particular resource offset.  
    Default: `0`. Minimum: 0.

#### Responses

*   **200** Get VariationGroups for a product was successful.
    
    Media type: `application/json`. Schema: `VariationGroups`.
    
    _Example: VariationGroupsResult_
    
    ```
    {
      "limit": 1,
      "data": [
        {
          "productId": "apple-ipod-classic-1",
          "variationValues": {
            "color": "Silver",
            "memorySize": "120 GB"
          }
        }
      ],
      "offset": 0,
      "total": 1
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Get a specific variation group.

`GET /organizations/{organizationId}/products/{masterProductId}/variation-groups/{id}`

Operation ID: `getVariationGroupForMasterProduct`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Read a variation group for a product.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId) The site context.

#### Responses

*   **200** Get VariationGroup by Id for a product was successful.
    
    Media type: `application/json`. Schema: `VariationGroup`.
    
    _Example: VariationGroupsIdResult_
    
    ```
    {
      "productId": "apple-ipod-classic-1",
      "variationValues": {
        "color": "Silver",
        "memorySize": "120 GB"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PUT Assign or create a variation group for a product.

`PUT /organizations/{organizationId}/products/{masterProductId}/variation-groups/{id}`

Operation ID: `assignVariationGroupToMasterProduct`. Security: AmOAuth2 (sfcc.products.rw).

Assign a variation group for a product. If the variation group product does not initially exist, one is created using the body passed in.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `VariationGroup`.

_Example: VariationGroupsIdRequestBody_

```
{
  "orderable": true,
  "price": 500,
  "productId": "apple-ipod-classic-1",
  "variationValues": {
    "color": "Silver",
    "memorySize": "120 GB"
  }
}
```

#### Responses

*   **200** Successfully assigned a variation group for given product.
    
    Media type: `application/json`. Schema: `VariationGroup`.
    
    _Example: VariationGroupsIdResult_
    
    ```
    {
      "productId": "apple-ipod-classic-1",
      "variationValues": {
        "color": "Silver",
        "memorySize": "120 GB"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Unassign a variation group (product not deleted).

`DELETE /organizations/{organizationId}/products/{masterProductId}/variation-groups/{id}`

Operation ID: `unassignVariationGroupFromMasterProduct`. Security: AmOAuth2 (sfcc.products.rw).

Unassign a variation group product from a product. The variation group product is not deleted: it remains as a typical product after unassign.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted the variation group successfully.
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PATCH Update an existing variation group.

`PATCH /organizations/{organizationId}/products/{masterProductId}/variation-groups/{id}`

Operation ID: `updateVariationGroupForMasterProduct`. Security: AmOAuth2 (sfcc.products.rw).

Update a variation group for a product master.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `VariationGroup`.

_Example: VariationGroupsIdRequestBody_

```
{
  "orderable": true,
  "price": 500,
  "productId": "apple-ipod-classic-1",
  "variationValues": {
    "color": "Silver",
    "memorySize": "120 GB"
  }
}
```

#### Responses

*   **200** Update was successful.
    
    Media type: `application/json`. Schema: `VariationGroup`.
    
    _Example: VariationGroupsIdResult_
    
    ```
    {
      "productId": "apple-ipod-classic-1",
      "variationValues": {
        "color": "Silver",
        "memorySize": "120 GB"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET List all variations of a master product.

`GET /organizations/{organizationId}/products/{masterProductId}/variations`

Operation ID: `getVariationsForMasterProduct`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

List all variations of a master product.

#### Parameters

*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId) The site context.
*   `limit` (query, integer (int32)) Number of records to retrieve per request. Must be between 1 (minimum) and 50 (maximum). Defaults to 25.  
    Default: `25`. Minimum: 1. Maximum: 50.
*   `offset` (query, integer (int32)) Used to retrieve the results based on a particular resource offset.  
    Default: `0`. Minimum: 0.

#### Responses

*   **200** Get variation by ID successful.
    
    Media type: `application/json`. Schema: `Variants`.
    
    _Example: getProduct400_
    
    ```
    {
      "limit": 4,
      "data": [
        {
          "productId": "apple-ipod-classic-silver-120g"
        },
        {
          "productId": "apple-ipod-classic-black-120g"
        },
        {
          "productId": "apple-ipod-classic-2"
        },
        {
          "productId": "apple-ipod-classic-blue-32g"
        }
      ],
      "offset": 0,
      "total": 4
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Get details of a specific variation.

`GET /organizations/{organizationId}/products/{masterProductId}/variations/{id}`

Operation ID: `getVariationForMasterProduct`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Get details of a specific variation.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `siteId` (query, SiteId) The site context.

#### Responses

*   **200** Get variation by ID successful.
    
    Media type: `application/json`. Schema: `Variant`.
    
    _Example: VariationsIdResult_
    
    ```
    {
      "defaultProductVariation": false,
      "productId": "apple-ipod-classic-blue-32g",
      "variationValues": {
        "color": "Blue",
        "memorySize": "32 GB"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PUT Assign a variation to a master product (creates if not exists).

`PUT /organizations/{organizationId}/products/{masterProductId}/variations/{id}`

Operation ID: `assignVariationForMasterProduct`. Security: AmOAuth2 (sfcc.products.rw).

Assign a variation for a product master. If the variation product does not initially exist, one is created using the body that is passed.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `Variant`.

_Example: VariationsIdRequestBody_

```
{
  "orderable": true,
  "price": 500,
  "productId": "apple-ipod-classic-blue-32g",
  "variationValues": {
    "color": "Blue",
    "memorySize": "32 GB"
  }
}
```

#### Responses

*   **200** Updated the variation product successfully.
    
    Media type: `application/json`. Schema: `Variant`.
    
    _Example: VariationsIdResult_
    
    ```
    {
      "defaultProductVariation": false,
      "productId": "apple-ipod-classic-blue-32g",
      "variationValues": {
        "color": "Blue",
        "memorySize": "32 GB"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Unassign a variation from a product (does not delete it).

`DELETE /organizations/{organizationId}/products/{masterProductId}/variations/{id}`

Operation ID: `unassignVariationFromMasterProduct`. Security: AmOAuth2 (sfcc.products.rw).

Unassign a variation product from a product. The variation product is not deleted: it remains as a typical product after unassign.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted the variation group successfully.
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PATCH Update a specific product variation.

`PATCH /organizations/{organizationId}/products/{masterProductId}/variations/{id}`

Operation ID: `updateVariationForMasterProduct`. Security: AmOAuth2 (sfcc.products.rw).

Update a variation for a product.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `masterProductId` (path, string, required) The ID of the master product that contains the variation group.  
    Minimum length: 1. Maximum length: 100. Example: `sony-ps3-bundle`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `Variant`.

_Example: VariationsIdRequestBody_

```
{
  "orderable": true,
  "price": 500,
  "productId": "apple-ipod-classic-blue-32g",
  "variationValues": {
    "color": "Blue",
    "memorySize": "32 GB"
  }
}
```

#### Responses

*   **200** Variation updated successfully.
    
    Media type: `application/json`. Schema: `Variant`.
    
    _Example: VariationsIdResult_
    
    ```
    {
      "defaultProductVariation": false,
      "productId": "apple-ipod-classic-blue-32g",
      "variationValues": {
        "color": "Blue",
        "memorySize": "32 GB"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Retrieve product options for a product.

`GET /organizations/{organizationId}/products/{productId}/product-options`

Operation ID: `getProductOptions`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Read local and shared product options for a specified product.

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `currency` (query, CurrencyCode) A three letter uppercase currency code conforming to the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard, or the string `N/A` indicating that a currency is not applicable.
    
    _Example: CurrencyCode_
    
    ```
    USD
    ```
    
*   `limit` (query, integer (int32)) Number of records to retrieve per request. Must be between 1 (minimum) and 50 (maximum). Defaults to 25.  
    Default: `25`. Minimum: 1. Maximum: 50.
*   `offset` (query, integer (int32)) Used to retrieve the results based on a particular resource offset.  
    Default: `0`. Minimum: 0.

#### Responses

*   **200** Retrieved product options successfully.
    
    Media type: `application/json`. Schema: `ProductOptions`.
    
    _Example: ProductOptionsResult_
    
    ```
    {
      "limit": 1,
      "data": [
        {
          "id": "digitalCameraWarranty",
          "values": [
            {
              "id": "001",
              "optionPrices": [
                {
                  "currencyMnemonic": "USD",
                  "value": 9.99
                }
              ],
              "value": {
                "default": "1 Year Warranty"
              }
            },
            {
              "id": "003",
              "optionPrices": [
                {
                  "currencyMnemonic": "USD",
                  "value": 29.99
                }
              ],
              "value": {
                "default": "5 Year Warranty"
              }
            },
            {
              "id": "000",
              "optionPrices": [
                {
                  "currencyMnemonic": "USD",
                  "value": 39.99
                }
              ],
              "value": {
                "default": "None"
              }
            },
            {
              "id": "002",
              "optionPrices": [
                {
                  "currencyMnemonic": "USD",
                  "value": 49.99
                }
              ],
              "value": {
                "default": "3 Year Warranty"
              }
            }
          ]
        }
      ],
      "offset": 0,
      "total": 1
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Retrieve a specific product option.

`GET /organizations/{organizationId}/products/{productId}/product-options/{id}`

Operation ID: `getProductOption`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Read a local or shared product option for a specified product.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `currency` (query, CurrencyCode) A three letter uppercase currency code conforming to the [ISO 4217](https://www.iso.org/iso-4217-currency-codes.html) standard, or the string `N/A` indicating that a currency is not applicable.
    
    _Example: CurrencyCode_
    
    ```
    USD
    ```
    

#### Responses

*   **200** Retrieved product options successfully.
    
    Media type: `application/json`. Schema: `ProductOption`.
    
    _Example: ProductOptionsIdResult_
    
    ```
    {
      "customName": {
        "default": "My Option"
      },
      "description": {
        "default": "Description for my option."
      },
      "id": "my-option",
      "image": {
        "absUrl": "https://example.com/on/demandware.static/-/Sites-XMaster/default/aaaaaaaabbbbbbbbbabababba/option.jpg",
        "disBaseUrl": "https://example.com/dw/image/v2/zzzz_s01/on/demandware.static/-/Sites-XMaster/default/aaaaaaaabbbbbbbbbabababba/option.jpg",
        "path": "option.jpg"
      },
      "name": "option",
      "shared": false,
      "sortingMode": "byoptionprice"
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PUT Create or bind a product option.

`PUT /organizations/{organizationId}/products/{productId}/product-options/{id}`

Operation ID: `createProductOption`. Security: AmOAuth2 (sfcc.products.rw).

Creates a local product option using the information provided or binds a shared product option to the product.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `ProductOption`.

_Example: ProductOptionsIdRequestBody_

```
{
  "id": "my-option",
  "customName": {
    "default": "My Option"
  },
  "description": {
    "default": "Description for my option."
  },
  "image": {
    "path": "option.jpg"
  }
}
```

#### Responses

*   **200** Updated product option successfully.
    
    Media type: `application/json`. Schema: `ProductOption`.
    
    _Example ProductOptionsIdResult: same as GET /organizations/{organizationId}/products/{productId}/product-options/{id} 200 response._
    
*   **201** Created or binded product option successfully.
    
    Media type: `application/json`. Schema: `ProductOption`.
    
    _Example ProductOptionsIdResult: same as GET /organizations/{organizationId}/products/{productId}/product-options/{id} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Delete or unbind a product option.

`DELETE /organizations/{organizationId}/products/{productId}/product-options/{id}`

Operation ID: `deleteProductOption`. Security: AmOAuth2 (sfcc.products.rw).

Delete a local product option or unbind a shared product option from the product.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted product option successfully.
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PATCH Update a product option.

`PATCH /organizations/{organizationId}/products/{productId}/product-options/{id}`

Operation ID: `updateProductOption`. Security: AmOAuth2 (sfcc.products.rw).

Update a local product option with the information provided.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `ProductOption`.

_Example: ProductOptionsIdRequestBody_

```
{
  "id": "my-option",
  "customName": {
    "default": "My Option"
  },
  "description": {
    "default": "Description for my option."
  },
  "image": {
    "path": "option.jpg"
  }
}
```

#### Responses

*   **200** Updated product option successfully.
    
    Media type: `application/json`. Schema: `ProductOption`.
    
    _Example ProductOptionsIdResult: same as GET /organizations/{organizationId}/products/{productId}/product-options/{id} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Retrieve a product option value.

`GET /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id}`

Operation ID: `getProductOptionValue`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Read a local product option value for a specified product.

#### Parameters

*   `productId` (path, ProductId, required)
*   `optionId` (path, string, required) The ID of the local product option.  
    Minimum length: 1. Maximum length: 256. Example: `sony-ps3-bundle`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **200** Successfully retrieved product option value.
    
    Media type: `application/json`. Schema: `ProductOptionValue`.
    
    _Example: ProductOptionsValuesResult_
    
    ```
    {
      "defaultProductOptionValue": false,
      "id": "value1",
      "optionPrices": [
        {
          "currencyMnemonic": "USD",
          "value": 100
        }
      ],
      "skuExtension": "s10",
      "value": {
        "default": "value 1",
        "en-US": "value 1(en-US)",
        "en": "value 1(en)"
      }
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PUT Create a product option value.

`PUT /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id}`

Operation ID: `createProductOptionValue`. Security: AmOAuth2 (sfcc.products.rw).

Create a local product option value using the information provided.

#### Parameters

*   `productId` (path, ProductId, required)
*   `optionId` (path, string, required) The ID of the local product option.  
    Minimum length: 1. Maximum length: 256. Example: `sony-ps3-bundle`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `ProductOptionValue`.

_Example: ProductOptionsValuesRequestBody_

```
{
  "id": "my-option",
  "value": {
    "default": "value 1",
    "en": "value 1(en)",
    "en-US": "value 1(en-US)"
  },
  "optionPrices": [
    {
      "currencyMnemonic": "USD",
      "value": 100
    }
  ],
  "skuExtension": "s10"
}
```

#### Responses

*   **200** Updated product option value successfully.
    
    Media type: `application/json`. Schema: `ProductOptionValue`.
    
    _Example ProductOptionsValuesResult: same as GET /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id} 200 response._
    
*   **201** Created product option value successfully.
    
    Media type: `application/json`. Schema: `ProductOptionValue`.
    
    _Example ProductOptionsValuesResult: same as GET /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Delete a product option value.

`DELETE /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id}`

Operation ID: `deleteProductOptionValue`. Security: AmOAuth2 (sfcc.products.rw).

Delete a local product option value by ID.

#### Parameters

*   `productId` (path, ProductId, required)
*   `optionId` (path, string, required) The ID of the local product option.  
    Minimum length: 1. Maximum length: 256. Example: `sony-ps3-bundle`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted product option value successfully.
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PATCH Update a product option value.

`PATCH /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id}`

Operation ID: `updateProductOptionValue`. Security: AmOAuth2 (sfcc.products.rw).

Update a local product option value using the information provided.

#### Parameters

*   `productId` (path, ProductId, required)
*   `optionId` (path, string, required) The ID of the local product option.  
    Minimum length: 1. Maximum length: 256. Example: `sony-ps3-bundle`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `ProductOptionValue`.

_Example ProductOptionsValuesRequestBody: same as PUT /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id} request._

#### Responses

*   **200** Product option value updated successfully.
    
    Media type: `application/json`. Schema: `ProductOptionValue`.
    
    _Example ProductOptionsValuesResult: same as GET /organizations/{organizationId}/products/{productId}/product-options/{optionId}/values/{id} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Retrieve a variation attribute value.

`GET /organizations/{organizationId}/products/{productId}/variation-attributes/{attributeId}/values/{id}`

Operation ID: `getVariationAttributeValue`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Get product variation attribute information.

#### Parameters

*   `productId` (path, ProductId, required)
*   `attributeId` (path, string, required) The variation attribute ID.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `siteId` (query, SiteId) The site context.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **200** Retrieved variation attribute value successfully.
    
    Media type: `application/json`. Schema: `VariationAttributeValue`.
    
    _Example: VariationAttributeValuesIdResult_
    
    ```
    {
      "description": {
        "default": "desc of 8 (default)",
        "en-US": "desc of 8 (en-US)",
        "en": "desc of 8 (en)"
      },
      "position": 1,
      "value": "8"
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PUT Create a variation attribute value.

`PUT /organizations/{organizationId}/products/{productId}/variation-attributes/{attributeId}/values/{id}`

Operation ID: `createVariationAttributeValue`. Security: AmOAuth2 (sfcc.products.rw).

Create a product variation attribute value.

#### Parameters

*   `productId` (path, ProductId, required)
*   `attributeId` (path, string, required) The variation attribute ID.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `VariationAttributeValue`.

_Example: VariationAttributeValuesIdRequestBody_

```
{
  "value": "8",
  "description": {
    "default": "desc of 8 (default)",
    "en": "desc of 8 (en)",
    "en-US": "desc of 8 (en-US)"
  }
}
```

#### Responses

*   **200** Created product variation attribute value successfully.
    
    Media type: `application/json`. Schema: `VariationAttributeValue`.
    
    _Example: VariationAttributeValuesIdResult_
    
    ```
    {
      "description": {
        "default": "desc of 8 (default)",
        "en-US": "desc of 8 (en-US)",
        "en": "desc of 8 (en)"
      },
      "position": 1,
      "value": "8"
    }
    ```
    
*   **201** Created product variation attribute value successfully.
    
    Media type: `application/json`. Schema: `VariationAttributeValue`.
    
    _Example: VariationAttributeValuesIdResult_
    
    ```
    {
      "description": {
        "default": "desc of 8 (default)",
        "en-US": "desc of 8 (en-US)",
        "en": "desc of 8 (en)"
      },
      "position": 1,
      "value": "8"
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Delete a variation attribute value.

`DELETE /organizations/{organizationId}/products/{productId}/variation-attributes/{attributeId}/values/{id}`

Operation ID: `deleteVariationAttributeValue`. Security: AmOAuth2 (sfcc.products.rw).

Delete the variation attribute value of a variation attribute bound to a product.

#### Parameters

*   `productId` (path, ProductId, required)
*   `attributeId` (path, string, required) The variation attribute ID.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted variation attribute value successfully.
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PATCH Update a variation attribute value.

`PATCH /organizations/{organizationId}/products/{productId}/variation-attributes/{attributeId}/values/{id}`

Operation ID: `updateVariationAttributeValue`. Security: AmOAuth2 (sfcc.products.rw).

Update the variation attribute value of a variation attribute of a product.

#### Parameters

*   `productId` (path, ProductId, required)
*   `attributeId` (path, string, required) The variation attribute ID.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `VariationAttributeValue`.

_Example: VariationAttributeValuesIdRequestBody_

```
{
  "value": "8",
  "description": {
    "default": "desc of 8 (default)",
    "en": "desc of 8 (en)",
    "en-US": "desc of 8 (en-US)"
  }
}
```

#### Responses

*   **200** Updated variation attribute value successfully.
    
    Media type: `application/json`. Schema: `VariationAttributeValue`.
    
    _Example: VariationAttributeValuesIdResult_
    
    ```
    {
      "description": {
        "default": "desc of 8 (default)",
        "en-US": "desc of 8 (en-US)",
        "en": "desc of 8 (en)"
      },
      "position": 1,
      "value": "8"
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Retrieve variation attributes of a product.

`GET /organizations/{organizationId}/products/{productId}/variation-attributes`

Operation ID: `getVariationAttributes`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Read variation attributes of a product of type variant, variation master, or variation group.

#### Parameters

*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    
*   `limit` (query, integer (int32)) Number of records to retrieve per request. Must be between 1 (minimum) and 50 (maximum). Defaults to 25.  
    Default: `25`. Minimum: 1. Maximum: 50.
*   `offset` (query, integer (int32)) Used to retrieve the results based on a particular resource offset.  
    Default: `0`. Minimum: 0.

#### Responses

*   **200** Retrieved the list of VariationAttributes for the product ID successfully.
    
    Media type: `application/json`. Schema: `VariationAttributes`.
    
    _Example: VariationAttributesResult_
    
    ```
    {
      "limit": 3,
      "data": [
        {
          "attributeDefinitionId": "color",
          "attributeDefinitionName": {
            "default": "Color"
          },
          "id": "color",
          "name": {
            "default": "Color"
          },
          "shared": true,
          "slicing": false,
          "values": [
            {
              "name": {
                "default": "Silver"
              },
              "position": 1,
              "value": "Silver"
            },
            {
              "name": {
                "default": "Black"
              },
              "position": 2,
              "value": "Black"
            },
            {
              "name": {
                "default": "Purple"
              },
              "position": 3,
              "value": "Purple"
            },
            {
              "name": {
                "default": "Blue"
              },
              "position": 4,
              "value": "Blue"
            },
            {
              "name": {
                "default": "Green"
              },
              "position": 5,
              "value": "Green"
            },
            {
              "name": {
                "default": "Yellow"
              },
              "position": 6,
              "value": "Yellow"
            },
            {
              "name": {
                "default": "Orange"
              },
              "position": 7,
              "value": "Orange"
            },
            {
              "name": {
                "default": "Red"
              },
              "position": 8,
              "value": "Red"
            },
            {
              "name": {
                "default": "Fuscia"
              },
              "position": 9,
              "value": "Fuscia"
            }
          ],
          "variationAttributeType": "string"
        },
        {
          "attributeDefinitionId": "memorySize",
          "attributeDefinitionName": {
            "default": "Memory Size"
          },
          "id": "memorySize",
          "name": {
            "default": "Memory Size"
          },
          "shared": true,
          "slicing": false,
          "values": [
            {
              "name": {
                "default": "1 GB"
              },
              "position": 1,
              "value": "1 GB"
            },
            {
              "name": {
                "default": "2 GB"
              },
              "position": 2,
              "value": "2 GB"
            },
            {
              "name": {
                "default": "8 GB"
              },
              "position": 3,
              "value": "8 GB"
            },
            {
              "name": {
                "default": "16 GB"
              },
              "position": 4,
              "value": "16 GB"
            },
            {
              "name": {
                "default": "32 GB"
              },
              "position": 5,
              "value": "32 GB"
            },
            {
              "name": {
                "default": "120 GB"
              },
              "position": 6,
              "value": "120 GB"
            }
          ],
          "variationAttributeType": "string"
        },
        {
          "attributeDefinitionId": "size",
          "attributeDefinitionName": {
            "default": "Size"
          },
          "id": "screenSize",
          "name": {
            "default": "Size"
          },
          "shared": false,
          "slicing": false,
          "values": [
            {
              "description": {
                "default": "desc of 8 (default)",
                "en-US": "desc of 8 (en-US)",
                "en": "desc of 8 (en)"
              },
              "position": 1,
              "value": "8"
            }
          ],
          "variationAttributeType": "string"
        }
      ],
      "offset": 0,
      "total": 3
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### GET Retrieve a specific variation attribute.

`GET /organizations/{organizationId}/products/{productId}/variation-attributes/{id}`

Operation ID: `getVariationAttribute`. Security: AmOAuth2 (sfcc.products, sfcc.products.rw).

Get variation attribute information only for master product.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **200** Retrieved the VariationAttribute for the product ID successfully.
    
    Media type: `application/json`. Schema: `VariationAttribute`.
    
    _Example: VariationAttributeResult_
    
    ```
    {
      "attributeDefinitionId": "size",
      "attributeDefinitionName": {
        "default": "Size"
      },
      "id": "screenSize",
      "name": {
        "default": "Size"
      },
      "shared": false,
      "slicing": false,
      "variationAttributeType": "string"
    }
    ```
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### PUT Create a variation attribute.

`PUT /organizations/{organizationId}/products/{productId}/variation-attributes/{id}`

Operation ID: `createVariationAttribute`. Security: AmOAuth2 (sfcc.products.rw).

Create a variation attribute using the information provided.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Request body (required)

Media type: `application/json`. Schema: `VariationAttribute`.

_Example: VariationAttributeRequestBody_

```
{
  "attributeDefinitionId": "size",
  "attributeDefinitionName": {
    "default": "Screen Size"
  }
}
```

#### Responses

*   **200** Created variation attribute successfully.
    
    Media type: `application/json`. Schema: `VariationAttribute`.
    
    _Example VariationAttributeResult: same as GET /organizations/{organizationId}/products/{productId}/variation-attributes/{id} 200 response._
    
*   **201** Created variation attribute successfully.
    
    Media type: `application/json`. Schema: `VariationAttribute`.
    
    _Example VariationAttributeResult: same as GET /organizations/{organizationId}/products/{productId}/variation-attributes/{id} 200 response._
    
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct401: same as GET /organizations/{organizationId}/products/{productId} 401 response._
    
*   **404** Resource requested not found.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct404: same as GET /organizations/{organizationId}/products/{productId} 404 response._
    

### DELETE Remove a variation attribute.

`DELETE /organizations/{organizationId}/products/{productId}/variation-attributes/{id}`

Operation ID: `deleteVariationAttribute`. Security: AmOAuth2 (sfcc.products.rw).

Delete the variation attribute by ID.

#### Parameters

*   `id` (path, string, required) The ID of the variation attribute to create.  
    Minimum length: 1. Maximum length: 256. Example: `colour`.
*   `productId` (path, ProductId, required)
*   `organizationId` (path, OrganizationId, required) An identifier for the Salesforce Commerce Cloud organization the request is being made by. It consists of a prefix 'f\_ecom\_' followed by a 4-character [realm identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#realm-id) and a 3-character [instance type identifier](https://developer.salesforce.com/docs/commerce/commerce-api/guide/base-url.html#instance-id).
    
    _Example_
    
    ```
    f_ecom_zzxy_prd
    ```
    

#### Responses

*   **204** Deleted variation attribute successfully.
*   **400** Bad Request. Thrown when a specified expand parameter value is unknown.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
    _Example getProduct400: same as GET /organizations/{organizationId}/products/{productId} 400 response._
    
*   **401** Unauthorized. Your Client ID is invalid, or you are not allowed to access the content provided by the requested URL.
    
    Media type: `application/problem+json`. Schema: `ErrorResponse`.
    
[...]
